{
File:  $Id: del_stat.pas,v 1.2 2003/08/20 09:35:46 skopaliks Exp $
------------------------------------------------------------------------------
    del_stat.pas - Interface to del_stat.dll,
                   it is able using FB/IB UDF direct in Delphi code

    Copyright (C) 2003  Slavomir Skopalik

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    e-mail:skopalik@hlubocky.del.cz
    http://hlubocky.del.cz/udf
------------------------------------------------------------------------------
Note: If You made any modification, please send me a copy.
}
unit del_stat;
interface
uses SysUtils;
type
  PInt=^LongInt;
  PDouble=^Double;
  EStatError=class(Exception);
const DEL_StatDll='del_stat.dll';

function StatInit:LongInt;
function StatInitEx(const Count:integer):LongInt;
function StatFree(const Handle:integer):LongInt;
function StatAdd(const Handle:integer; const Value:double):LongInt;
function StatGetItem(const Handle:integer; const index:integer):double;
function StatCount(const Handle:integer):LongInt;
function StatMin(const Handle:integer):double;
function StatMax(const Handle:integer):double;
function StatClear(const Handle:integer):LongInt;
function StatDuplicate(const Handle:integer):LongInt;
function StatRMS(const XValues,YValues,degree:integer):LongInt;   // result is handle to NEW Stat object that contain poly coef.
function StatPoly(const Handle:integer; const Value:double):double;
function StatSort(const Handle:integer):LongInt;
function StatMedian(const Handle:integer):double;
function StatMean(const Handle:integer):double;
function StatStdDevSel(const Handle:integer):double;

implementation
function _StatInit:LongInt;cdecl;external DEL_StatDll;
function _StatInitEx(Count:PInt):LongInt;cdecl;external DEL_StatDll;
function _StatFree(Handle:pint):LongInt;cdecl;external DEL_StatDll;
function _StatAdd(Handle:pint;Value:Pdouble):LongInt;cdecl;external DEL_StatDll;
function _StatGetItem(Handle:pint;index:Pint):double;cdecl;external DEL_StatDll;
function _StatCount(Handle:pint):LongInt;cdecl;external DEL_StatDll;
function _StatMin(Handle:pint):double;cdecl;external DEL_StatDll;
function _StatMax(Handle:pint):double;cdecl;external DEL_StatDll;
function _StatClear(Handle:pint):LongInt;cdecl;external DEL_StatDll;
function _StatDuplicate(Handle:pint):LongInt;cdecl;external DEL_StatDll;
function _StatRMS(XValues,YValues,degree:pint):LongInt;cdecl;external DEL_StatDll;
function _StatPoly(Handle:pint;Value:Pdouble):double;cdecl;external DEL_StatDll;
function _StatSort(Handle:pint):LongInt;cdecl;external DEL_StatDll;
function _StatMedian(Handle:pint):double;cdecl;external DEL_StatDll;
function _StatMean(Handle:pint):double;cdecl;external DEL_StatDll;
function _StatStdDevSel(Handle:pint):double;cdecl;external DEL_StatDll;

function StatInit:LongInt;
begin
  result:=_StatInit;
  if result=0 then raise EStatError.Create('Can''t initialize statistic object');
end;

function StatInitEx(const Count:integer):LongInt;
begin
  result:=_StatInitEx(@Count);
  if result=0 then raise EStatError.CreateFmt('Can''t initialize statistic object (count:%d)',[Count]);
end;

function StatFree(const Handle:integer):LongInt;
begin
  result:=_StatFree(@Handle);
end;

function StatAdd(const Handle:integer; const Value:double):LongInt;
begin
  result:=_StatAdd(@Handle,@Value);
end;

function StatGetItem(const Handle:integer; const index:integer):double;
begin
  result:=_StatGetItem(@Handle,@index);
end;

function StatCount(const Handle:integer):LongInt;
begin
  result:=_StatCount(@Handle);
end;

function StatMin(const Handle:integer):double;
begin
  result:=_StatMin(@Handle);
end;

function StatMax(const Handle:integer):double;
begin
  result:=_StatMax(@Handle);
end;

function StatClear(const Handle:integer):LongInt;
begin
  result:=_StatClear(@Handle);
end;

function StatDuplicate(const Handle:integer):LongInt;
begin
  result:=_StatDuplicate(@Handle);
end;

function StatRMS(const XValues,YValues,degree:integer):LongInt;
begin
  result:=_StatRMS(@XValues,@YValues,@degree);
end;

function StatPoly(const Handle:integer; const Value:double):double;
begin
  result:=_StatPoly(@Handle,@Value);
end;

function StatSort(const Handle:integer):LongInt;
begin
  result:=_StatSort(@Handle);
end;

function StatMedian(const Handle:integer):double;
begin
  result:=_StatMedian(@Handle);
end;

function StatMean(const Handle:integer):double;
begin
  result:=_StatMean(@Handle);
end;

function StatStdDevSel(const Handle:integer):double;
begin
  result:=_StatStdDevSel(@Handle);
end;

end.
